import( stdio float clock )


var itime double ;
var ftime double ;
var mtime double ;

macro my/ [ $FBF7 ] ; ( IDIV BX )
macro my* [ $EBF7 ] ; ( IMUL BX )
: intest
  " Integer unit speed             :   " $.
  0timer
  , 5
  50000 for
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/        
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
      +  -  my*  my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  +  -  my*   my/  
  next
  itime gettimer 
  %1000000 itime d/m>f %100 f/ f/ %100000 f/ 
  f. "  MIPS " $.    
  cr cr
;      

: Floattest
  " Floating point unit speed      :   " $.
  0timer
  f1 f1
  5000 for
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup 
    f+ fdup f+ fdup  f* fdup f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup f+ fdup  f* fdup   f/ fdup
  next
  ftime gettimer 
  %1000000 ftime d/m>f %100 f/ f/
  %1000000 f/ f. "  MFLOPS " $.  
  cr cr
;


: Transtest
  " FPU trigon. function speed     :   " $.
  0timer
  %3.52143
  1250 for
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
    fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos fsin fcos 
  next
  ftime gettimer 
  %250000 ftime d/m>f %100 f/ f/ %1000 f/ f. "  KFLOPS " $.  
  cr cr
;



: movtest
  " Memory register move speed     :   " $.
  0timer
  , $AAAA
  50000 for
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
  next  
  mtime gettimer 
  %1000000 mtime d/m>f %100 f/  f/ %100000 f/ f. "  MB/sec " $.
  cr cr
;


: videotest
  " Videomemory register move speed:   " $.
  0timer
  dspush vptr [ $C5 $34 ] 
  , $AAAA
  5000 for
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
    m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m  m>a a>m m>b b>m    
  next 
  dspop 
  mtime gettimer 
  %1000000 mtime d/m>f %100 f/ f/ %1000000 f/ f. "  MB/sec " $.
  cr cr
;

: main init
  " NAXOS V2.13 Mini-benchmark  V1.01 386/387+ only  22/09/93" $. cr
  " (C) 1993 by A.Zissis" $. cr cr cr cr
  bl leading bl>m
  intest
  movtest  
  videotest
  floattest
  transtest

;    
  
  
 