import( stdio pointer sprites )
var stdpal paltype ;
var scheiss byte 12650 ; ( 10 sprites * 1265 )
var abort bool ;
var player1 word ;
var player2 word ;
var xadr word ;


: pause 
  begin 
  .?key. until 
;

: getkey
  (long)
  .?key. IF key
     case
     'p' of  pause ;;
     'q' of  0 , -3 to 1 sprite-motion ;;     
     'a' of  0 ,  0 to 1 sprite-motion ;;
     'y' of  0 ,  3 to 1 sprite-motion ;;
     '9' of  0 , -3 to 2 sprite-motion ;;
     '6' of  0 ,  0 to 2 sprite-motion ;;     
     '3' of  0 ,  3 to 2 sprite-motion ;;
     27 of abort true bl>m ;;
     endcase
  ENDIF
  (short)
;  

function clearsprites [ ]
var xadr word ;
begin
  maxsprite , 0 do
  ipush
    sprites i>a 1265 * adrn+ adr>a xadr a>local 
    xadr local>adr , $4ec adrn+ m>al .true=. flag>
    xadr local>adr m>a *-1 .<>. .>and. IF
      xadr local>adr sprite-restore
    ENDIF
   ipop 
  , 1 -loop
;

var strdum string 20 ;
: actscore 
  clearsprites
  player1 m>a 10 u/  .0=. 
  IF " 0.SPR" to strdum strcpy ELSE
     0 <# #s #> adrpush " .SPR" adr>a adrpop to strdum concat 
  ENDIF 
  strdum 4 sprite-load  130 , 3   to 4 sprite-xy
  player1 m>a 10 u/  b>a .0=. 
  IF " 0.SPR" to strdum strcpy ELSE
     0 <# #s #> adrpush " .SPR" adr>a adrpop to strdum concat 
  ENDIF 
  strdum  5 sprite-load  145 , 3   to 5 sprite-xy
  player2 m>a 10 u/  .0=. 
  IF " 0.SPR" to strdum strcpy ELSE
     0 <# #s #> adrpush " .SPR" adr>a adrpop to strdum concat 
  ENDIF
  strdum 6 sprite-load  175 , 3   to 6 sprite-xy
  player2 m>a 10 u/  b>a .0=. 
  IF " 0.SPR" to strdum strcpy ELSE
     0 <# #s #> adrpush " .SPR" adr>a adrpop to strdum concat 
  ENDIF
  strdum 7 sprite-load  190 , 3   to 7 sprite-xy
;


: muh
  80 , 60 do
    i>b sound 10 
  , 2 -loop
  nosound
;      

: bound
  300 sound 10 delay nosound
;  

: ping
  600 sound 10 delay nosound
;

: pong
  500 sound 10 delay nosound
;


: main init
  (long)
  memsizes( $1000 $1000 )
  make key (key-noecho)
  scheiss sprite-alloc 
  abort false bl>m
  clrscr
  virtual-screen new
  virtual-screen 0 , 32000 memfill
  " 0.SPR "    4 sprite-load  130 , 3   to 4 sprite-xy
  " 0.SPR "    5 sprite-load  145 , 3   to 5 sprite-xy
  " DP.SPR "   3 sprite-load  160 , 3   to 3 sprite-xy
  " 0.SPR "    6 sprite-load  175 , 3   to 6 sprite-xy
  " 0.SPR "    7 sprite-load  190 , 3   to 7 sprite-xy
 drawsprites   
 35 , 11 c-xy " Loading..." $. cr
  " TITLE.PCX" to virtual-screen loadpcx

 15 ,  8 c-xy " Player 1 :                              : Player 2" $. 
 15 ,  9 c-xy " ---------+------------------------------+---------" $.
 15 , 10 c-xy  " move up  :    Q                     9   :  move up" $. 
 15 , 11 c-xy " stop     :    A                     6   :     stop" $.
 15 , 12 c-xy " move down:    Y                     3   :move down" $. 
 30 , 16 c-xy " Press a key to play..." $. key

  $13 setgrmode
  stdpal getpalette
  768 for paltype i adrn+ 9 bl>m next paltype setpalette

  sprite-show 
  stdpal fadein

  " BACK.PCX" to virtual-screen loadpcx
  
  " stick.SPR" 1 sprite-load   21 , 100 to 1 sprite-xy
  " stick.SPR" 2 sprite-load  290 , 100 to 2 sprite-xy
  " ball.SPR"  0 sprite-load  160 , 100 to 0 sprite-xy

  2 , -2 to 0 sprite-motion
  
  begin
    getkey
    update
    0 , 8000 biosdelay
    0 , 2 do
     i .0=. IF
      sprites i sprsize3 * adrn+ adr>a xadr a>m
      xadr m>adr , 4 adrn+ m>a 21  .<. flag> 290 .>. .>or. IF
         , sprsize3 4 - xadr m>adr  
         adrn+ m>a neg a>m
      ENDIF
      xadr m>adr , 6 adrn+ m>a 26 .<. flag> 164 .>. .>or. IF
          , sprsize3 2- xadr m>adr 
          adrn+ m>a neg a>m
          bound 
      ENDIF
     ELSE
       sprites i sprsize3 * adrn+ adr>a xadr a>m
      xadr m>adr , 6 adrn+ m>a 26 .<. flag> 149 .>. .>or. IF
          , sprsize3 2- xadr m>adr 
          adrn+ m>a neg a>m
      ENDIF
     ENDIF 
    loop
    drawsprites
    sprite-show 
    0 , 1  .sprite-collision. 
    if 
      2 bpush a>d abs 7 and [ $D1 $D7 ] .not. 
      IF 
        neg 
      ENDIF 
      bpop to 0 sprite-motion 
      ping	
    endif
    0 , 2  .sprite-collision. 
    if 
      -2 bpush a>d abs 7 and [ $D1 $D7 ] .not. 
      IF 
        neg 
      ENDIF 
      bpop to 0 sprite-motion  
      pong
      endif 
    to 0 sprite-xy? , 21 .>. 
    IF 
      160 , 100 to 0 sprite-xy 
      player2 mem+
      actscore
      drawsprites  
      sprite-show
      muh
    ENDIF
    to 0 sprite-xy? , 290 .<. 
    IF 
      160 , 100 to 0 sprite-xy 
      player1 mem+
      actscore 
      drawsprites  
      sprite-show       
      muh	
    ENDIF
    abort m>al .true=. flag> 
    player1 m>a 20 .>. .>or. flag>
    player2 m>a 20 .>. .>or.  
  until
  fadeout
  3 setgrmode
  player1 m>a player2 m>b .>. IF " Player1 won" ELSE " Player2 won" ENDIF $. cr
  key
;
