(
	************************************************************
	*         NAXOS Version 2.13  16-Bit Runtime library       *
	*                                                          *
	*           Pointer support macros      V1.00              *
	*                                                          *
	* (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
	*                                                          *
	*                      Rev. 13B 25.08.93                   *
	*                                                          *
	************************************************************
)


	macro setptrsize
	( ** define size/type of pointer ** )
	( ********************************* )
	( arg:  BX = size		    )
	(	SI = ptr-adr		    )
	( ********************************* )
	adr2+ adr2+ b>m
	;		

	: defptr
	( ** define size/type of pointer ** )
	( ********************************* )
	( arg:  DI = size		    )
	(	ES = addr of typedef struc  )
	( 	BX:AX = pointing addr	    )
	(	SI = ptr-adr		    )
	( ********************************* )
	ba>m
	adr2+ adr2+ ed>m
	;		

		   MACRO ^>a 
	( **  word from ptr^ to AX ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: AX:= n from [pointer]  )
	( chg: AX,ES,SI               )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8B $04 ]    ( mov  ax,es:[si] )
	;

		   MACRO ^>al 
	( **  byte from ^ptr to AL ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: AL:= c from [pointer]  )
	( chg: AL,AH,ES,SI            )
	( *************************** ) 
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8A $04 ]    ( mov  al,es:[si] )
	[ $30 $E4 ]        ( xor  ah,ah   )
	;

		 MACRO ^>b 
	( **  word from ptr^ to BX ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: BX:= value from [ptr]  )
	( chg: BX,ES,SI               )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8B $1C ]     ( mov bx,es:[si] )
	;

		   MACRO ^>bl 
	( **  byte from ptr^ to BL ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: BL:= value from [ptr]  )
	( chg: BX,ES,SI               )
	( *************************** )
	[ $C4 $34 ]     ( les si,[si] )
	[ $26 $8A $1C ] ( mov bl,es:[si] )
	[ $30 $FF ]     ( xor bh,bh   )
	;

		 MACRO ^>i 
	( **  word from ptr^ to CX ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: CX:= value from [ptr]  )
	( chg: CX,ES,SI               )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8B $0C ]     ( mov cx,es:[si] )
	;

		   MACRO ^>il 
	( **  byte from ptr^ to CL ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: CL:= value from [ptr]  )
	( chg: CX,ES,SI               )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8A $0C ]     ( mov cl,es:[si] )
	[ $30 $ED ]     ( xor ch,ch   )
	;


		   MACRO ^>d 
	( **  word from ptr^ to DI ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: DI:= value from [ptr]  )
	( chg: DI,ES,SI               )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8B $3C ]   ( mov di,es:[si]   )
	;

		   MACRO ^>dl 
	( *  byte from ptr^ to DI-L * )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: DI:= value from [ptr]  )
	( chg: DI,ES,SI               )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8A $14 ]   ( mov dl,es:[si]   )
	[ $B6 $00 ]   ( mov dh,0      )
	[ $89 $D7 ]   ( mov di,dx     )
	;


		   MACRO ^>e 
	( **  word from ptr^ to ES ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: ES:= value from [ptr]  )
	( chg: ES,S   I               )
	( *************************** )

	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8E $04 ]     ( mov es,es:[si] )
	;

		 MACRO ^>adr 
	( **  word from ptr^ to SI ** )
	( *************************** )
	( arg: SI = pointer-adr       )
	( out: SI:= value from [ptr]  )
	( chg: ES,SI                  )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8B $34 ]    ( mov  si,es:[si] )
	;


		  MACRO ^>ba 
	( * double from ptr^ to BX:AX * )
	( ***************************   )
	( arg: SI = pointer-adr         )
	( out: BX:AX = value from [ptr] )
	( chg: AX,BX,ES,SI              )
	( *************************** )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $8B $5C 2 ] ( mov bx,es:[si+2] )
	[ $26 $8B $04   ] ( mov ax,es:[si]   )
	;

		   MACRO ^>ed 
	( * double from ptr^ to ES:DI * )
	( ***************************   )
	( arg: SI = pointer-adr        )
	( out: ES:DI= value from [ptr] )
	( chg: DI,ES,SI                )
	( ***************************  )
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $C4 $3C ]     ( les di,es:[si] )
	;

		 MACRO a>^
	(  store word from AX to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      AX to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $89 $04 ]    ( mov es:[si],ax )
	;

		 MACRO al>^
	(  store byte from AL to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      AL to [ptr[si]]        )
	( chg: ES,SI                  )
	( *************************** ) 
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $88 $04 ]    ( mov  es:[si],al )
	;

		MACRO b>^
	(  store word from BX to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      BX to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]        ( les si,[si] )
	[ $26 $89 $1C ]     ( mov es:[si],bx )
	;

		MACRO bl>^
	(  store byte from BL to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      BL to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $88 $1C ]     ( mov es:[si],bl )
	;

		MACRO i>^
	(  store word from CX to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      CX to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]         ( les si,[si] )     
	[ $26 $89 $0C ]     ( mov es:[si],cx )
	;

		MACRO il>^
	(  store byte from CL to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      CL to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $88 $0C ]     ( mov es:[si],cl )
	;

		 MACRO d>^
	(  store word from DI to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      DI to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $89 $3C ]     ( mov es:[si],di )
	;

		 MACRO dl>^
	(  store byte from DI-L to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      DI-L to [ptr[si]]      )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]         ( les si,[si] )
	[ $89 $FA ]     ( mov dx,di )
	[ $26 $88 $14 ] ( mov es:[si],dl )
	;

		 MACRO e>^
	(  store word from ES to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      ES to [ptr[si]]        )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $8C $C2 ]     ( mov dx,es ) 
	[ $C4 $34 ]     ( les si,[si] )
	[ $26 $89 $14 ] ( mov [si],dx )
	;


		 MACRO ba>^
	(  store double from BX:AX to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      BX:AX to [ptr[si]]     )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $89 $04 ]   ( mov es:[si],ax   )
	[ $26 $89 $5C 2 ] ( mov es:[si+2],bx )
	;

		: ed>^
	(  store double from ES:DI to [ptr] )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      ES:DI to [ptr[si]]     )
	( chg: ES;SI                  )
	( *************************** ) 
	[ $06 ]           ( push es )
	[ $C4 $34 ]       ( les si,[si] )
	[ $26 $89 $3C ]   ( mov es:[si],di   )
	[ $5A ]           ( pop dx )
	[ $26 $89 $54 2 ] ( mov [si+2],dx )
	;
 

		MACRO ^n+ 
	( ** add n to word in [ptr] * )
	( *************************** )
	( arg: AX = value n           )
	(      SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem+n)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]    ( les si,[si] )
	[ $26 $01 $04 ]    ( add  es:[si],ax )
	;

		 MACRO b/^n+ 
	( ** add c to byte in [ptr] * )
	( *************************** )
	( arg: AX = value c           )
	(      SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem+c)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $00 $04 ]     ( add es:[si],al ) 
	;

		  MACRO ^+ 
	( **  inc word in [ptr] by 1 ** )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem+1)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]          ( les si,[si] )
	[ $26 $FF $04 ]      ( inc  es:[si]  )
	;

		MACRO b/^+ 
	( **  inc byte in [ptr] by 1 ** )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem+1)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $FE $04 ]    ( inc  b/es:[si]  )
	;

		 MACRO ^- 
	( **  dec word in [ptr] by 1 ** )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem-1)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $FF $0C ]      ( dec es:[si]  )
	;

		MACRO b/^- 
	( **  dec byte in [ptr] by 1 ** )
	( *************************** )
	( arg: SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem-1)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $FE $0C ]    ( dec  b/es:[si]  )
	;

		MACRO ^n-
	( **  add n to word in [ptr] ** )
	( *************************** )
	( arg: AX = value n           )
	(      SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem-n)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $29 $04 ]     ( sub es:[si],ax )
	;

		 MACRO b/^n-
	( **  add c to byte in [ptr] ** )
	( *************************** )
	( arg: AX = value c           )
	(      SI = ptr-adr           )
	( out: -                      )
	(      (mem):=(mem-c)         )
	( chg: -                      )
	( *************************** )
	[ $C4 $34 ]         ( les si,[si] )
	[ $26 $28 $04 ]     ( sub es:[si],al ) 
	;


		MACRO b/^>^
	( copy byte from [ptr] to [ptr] )
	( ************************* )
	( arg: SI = source-ptr      )
	(      DI = destin-ptr      )
	( out: -                    )
	( chg: ES,SI,DI             )
	( ************************* )
	[ $1e ]           ( push ds )
	[ $C4 $3D ]       ( les di,[di] )
	[ $C5 $34 ]       ( lds si,[si] )
	[ $A4 ]           ( movsb   )
	[ $1F ]           ( pop ds )
	;

		MACRO ^>^
	( copy word from [ptr] to [ptr] )
	( ************************* )
	( arg: SI = source-ptr      )
	(      DI = dest-ptr        )
	( out: -                    )
	( chg: ES,SI,DI             )
	( ************************* )   
	[ $1e ]           ( push ds )
	[ $C4 $3D ]       ( les di,[di] )
	[ $C5 $34 ]       ( lds si,[si] )
	[ $A5 ]           ( movsw   )
	[ $1F ]           ( pop ds )
	;


		MACRO d/^>^
	( copy double from [ptr] to [ptr] )
	( *************************** )
	( arg: SI = source-ptr        )
	(      DI = dest-ptr          )
	( out: -                      )
	( chg: ES,SI,DI               )
	( *************************** )
	[ $1e ]           ( push ds )
	[ $C4 $3D ]       ( les di,[di] )
	[ $C5 $34 ]       ( lds si,[si] )
	[ $A5 $A5 ]       ( movsw, movsw   )
	[ $1F ]           ( pop ds )
	;


	: ptr>ptr
  ( copy contents of one pointer to another )
  ( checks size of target )
  ( arg:	SI := Source ptr )
  (		DI := Dest. ptr )

  [ $06 		( push es )
    $1E	    		( push ds ) 
    $8B $55 $04 	( mov dx,[di+4] )
    $2B $54 $04 	( sub dx,[si+4] )
    $81 $E2 $8000 	( cmp dx,$8000 )
    $75 $09		( jnz +9 )
    $C4 $3D		( les di,[di] )
    $C5 $34		( lds si,[si] )
    $8B $4C $04		( mov cx,[si+4] )
    $D1 $E9 ]		( shr cx,1 ; Loop # of bytes div 2 )
    IF [		( IF uneven number then xfer 1 Byte )
         $41      ( inc cx      )
         $A4 ]    ( movsb       )
    ENDIF
    [ $F3 $A5		( rep movsw ; transfer words )	
    $1F			( pop ds )
    $07 ]       	( pop es )
;

		 : ^b/fill 
	( fill i bytes in [ptr] with c )
	( ************************** )
	( arg: SI = ptr-adr          )
	(      BL = char c           )
	(      AX = count i          )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	dspush
	[ $C5 $34 ]    ( lds si,[si] )	
	[ $91 ]        ( xchg cx,ax  )
	[ $93 ]        ( xchg ax,bx  )
	[ $8C $DA ]    ( mov  dx,ds  )
	[ $8E $C2 ]    ( mov  es,dx  )
	[ $89 $F7 ]    ( mov  di,si  )
	[ $F3 $AA ]    ( rep  stosb  )
	[ $89 $D9 ]    ( mov  cx,bx  )
	dspop
	;

		  : ^fill 
	( fill i words in [ptr] with n )
	( ************************** )
	( arg: SI = ptr-adr          )
	(      BL = value n          )
	(      AX = count i <32000   )
	( out: -                     )
	( chg: ES,DI,BX,AX           )
	( ************************** )
	dspush
	[ $C5 $34 ]     ( lds si,[si] )	
	[ $91 ]         ( xchg cx,ax )
	[ $93 ]         ( xchg ax,bx )
	[ $8C $DA ]     ( mov  dx,ds )
	[ $8E $C2 ]     ( mov  es,dx )
	[ $89 $F7 ]     ( mov  di,si )
	[ $F3 $AB ]     ( rep  stosw )
	[ $89 $D9 ]     ( mov  cx,bx )
	dspop
	;


		 MACRO i^>a 
	( word from indexed [ptr] to AX )
	( *************************** )
	( arg: SI = ptr-adr           )
	(      BX = index i           )
	( out: AX:= n from PS:[PO+BX] )
	( chg: AX,ES,SI               )
	( *************************** ) 
	[ $C4 $34 ]  ( les si,[si] )
	[ $D1 $E3 ]  ( shl bx,1       )
	[ $26 $8B $00 ]  ( mov ax,es:[si+bx] )
	;

		 MACRO i^>al 
	( byte from indexed [ptr] to AL )
	( *************************** )
	( arg: SI = ptr-adr           )
	(      BX = index i           )
	( out: AL:= n from PS:[PO+BX] )
	( chg: AX,ES,SI               )
	( *************************** ) 
        [ $C4 $34 ]        ( les si,[si] )
	[ $26 $8A $00 ]    ( mov al,es:[si+bx] )
	[ $B4 $00 ]        ( mov ah,00      )
	;

		 MACRO a>i^ 
	( **  store AX with index   ** )
	( ** at adr = base_adr+2*i  ** )
	( **************************** )
	( arg: AX = value n to store   )
	(      BX = index              )
	(      SI = ptr-adr           )
	( out: -                       )
	( chg: BX                      )
	( **************************** )
        [ $C4 $34 ]        ( les si,[si] )
	[ $D1 $E3 ]  ( shl bx,1        )
	[ $26 $89 $00 ]  ( mov es:[si+bx],ax  )
	;

		MACRO al>i^
	( **  store AL with index   ** )
	( **  at adr = base_adr+i   ** )
	( **************************** )
	( arg: AX = value n to store   )
	(      BX = index              )
	(      SI = base_adr           )
	( out: -                       )
	( chg: BX                      )
	( **************************** )
        [ $C4 $34 ]        ( les si,[si] )
	[ $26 $88 $00 ]  ( mov es:[si+bx],al  )
	;

( ------------------------------------------------------- )
( | 		virtual method support			| )
( ------------------------------------------------------- )

macro GM>A  ( m>a from global-memory= original DS )
      dspush
      ds!
      m>a
      dspop
;      	
: GM>AL  ( m>al from global-memory= original DS )
      dspush
      ds!
      m>al
      dspop
;      	

macro GM>B  ( m>b from global-memory= original DS )
      dspush
      ds!
      m>b
      dspop
;      	
: GM>BL  ( m>bl from global-memory= original DS )
      dspush
      ds!
      m>bl
      dspop
;      	
: GM>BA  ( m>ba from global-memory= original DS )
      dspush
      ds!
      m>ba
      dspop
;      	

macro A>GM  ( a>m to global-memory= original DS )
      dspush
      ds!
      a>m
      dspop
;      	
: AL>GM  ( al>m to global-memory= original DS )
      dspush
      ds!
      al>m
      dspop
;      	

macro B>GM  ( b>m to global-memory= original DS )
      dspush
      ds!
      b>m
      dspop
;      	
: BL>GM  ( bl>m to global-memory= original DS )
      dspush
      ds!
      bl>m
      dspop
;      	
: BA>GM  ( ba>m to global-memory= original DS )
      dspush
      ds!
      m>ba
      dspop
;      	