import( stdio clock float )

var GO-Z	float ;
var GO-	float ;

var Datum	byte 4 ;
var LfdNr	word ;

var PatNr	word ;
var Name	string 40 ;
var Vornamen	string 40 ;
var PK		string 15 ;
var Einheit	string 70 ;
var Dienstgrad	string 10 ;
var Dsteintritt	string 11 ;
var DZE		string 11 ;
var status	byte ; ( 0=GwdL,1=SaZ,2=BS,3=W,,4=zivil,5=ziv/privat )
var TelefonD	string 20 ;
var TelefonP	string 40 ;
var Lastrech	" 00.00.0000" ;

var Memo	string 80 ;
var buf	        string 80 ;


record Lstg
  var Datum 	byte 4 ;
  var Zahn  	byte ;
  var Anzahl    byte ;
  var Ziffer 	word ;   
  var Faktor	word ;
;


var PatFile file ;

record BEMArec	
  var Nr	word ;		( 2 Byte )
  var Text      string 5 ;      ( 6 Byte )
  var Ziffer    string 5 ;      ( 6 Byte )
  var Wert      word ;		( 2 Byte )
  var GOZ       word ;          ( 2 Byte )
  var GOZWert   word ;          ( 2 Byte, Wert in  Pf. )
  var GOZFaktor word ;          ( 2 Byte Steigerungssatz x10 )
;  

var BEMA 	byte 8192 ;  
var BEMAfile 	file ;
var Befund 	byte 32  ;

var count 	word ;

var RECHNFILE	file ;

(
record rechn
var Status	byte ;
var LfdNr	word ;
var PatNr	word ;
var START	word ;
var Gestellt	double ;
var Bezahlt	double ;
var Summe	float ;
;
)

var RECHLfdNr word ;

: putBEMArec
  16* 2* BEMA adrn+ adr>d BEMArec , 31 i/copy
;

: getBEMArec
  16* 2* BEMA adrn+ to BEMArec , 31 i/copy
;

var (DM) double ;
: DM. ( Arg in ST(0) float )
  leading m>al apush , $20 leading al>m
  %100 f*
  (DM) d/F>M  
  (dm) m>ba <# # # ',' hold # # # # #> $.   
  apop leading al>m
;

: xkey
  key
  .0=. IF
    KEY 256 +
   ELSE 
    ah0
   ENDIF 
;   
   
: .$=. overload
( * Compare two strings * )
( arg:  DS:SI := string1  )
(	ES:DI := string2  )
( out:  CF=1 if equal	  )
( compares only until end )
( of SI string	          )
( *********************** )
   strlen a>i 
  [ $F3 $A6		( repz cmpsb )
    $F8			( clc )
    $75 01		( jnz  +1 )
    $F5	]		( cmc )
;  


var TGSTR string 15 ;
var (datum) double ;

proc N2DAT ( in: date inBX:AX, out Datestr in SI )
  (datum) ba>m
  (datum) m>al 0 <# # # #> to tgstr strcpy 
  " ." adr>a tgstr to buf concat
  (datum) adr+ m>al 0 <# # # #> adr>a buf to tgstr concat
  " ." adr>a tgstr to buf concat
  (datum) adr2+ m>a 0 <# # # # # #> adr>a buf to tgstr concat
  tgstr
;

proc DAT2N ( in Datestr in SI ,out date in BX:AX )
  to tgstr strcpy
  tgstr adr2+ 0 bl>m adr2+ adr+ 0 bl>m
  tgstr m>al '0' - 10* adr+ apush m>al '0' - bpop + (datum) al>m
  tgstr adr2+ adr+ m>al '0' - 10* adr+ apush 
        m>al '0' - bpop + (datum) adr+ al>m     
  tgstr adr2+ adr2+ adr2+ .number. (datum) adr2+ a>m
  (datum) m>ba
;

proc upstr
  BEGIN
    m>al .0<>. IF
       $20 or al>m adr+ .F.
    ELSE .T.  
    ENDIF
  UNTIL  
;

proc getBEMA
  " BEMA.TXT" to BEMAfile fassign
  BEMAfile fopen
  BEGIN
    BEMAfile to buf Fget$
    buf , $03 adrn+ 0 bl>m ( Nr.	00..02 )
    buf , $09 adrn+ 0 bl>m ( Text 	04..08 )
    buf , $0F adrn+ 0 bl>m ( BEMAZiff	0A..0E )
    buf , $13 adrn+ 0 bl>m ( BEMAWert	10..12 )
    buf , $19 adrn+ 0 bl>m ( GOZZiff 	14..18 )
    buf , $1F adrn+ 0 bl>m ( GOZWert	1A..1E )
    buf , $24 adrn+ 0 bl>m ( GOZFaktor	20..23 )
  
    buf .number.  BEMArec_Nr a>m
    BEMArec_Text adr>d buf , 4 adrn+ strcpy 
    BEMArec_Ziffer adr>d buf , $A adrn+ strcpy 
    buf , $10 adrn+ .number. BEMArec_Wert a>m 
    buf , $14 adrn+ .number. BEMArec_GOZ a>m
    buf , $1A adrn+ .number. BEMArec_GOZWert a>m
    buf , $20 adrn+ .number. BEMArec_GOZFaktor a>m

    BEMArec_NR m>a putBEMArec  

  BEMAfile .eof. UNTIL  
  BEMAfile fclose


  1 count b>m
;


var (cmpstr) string 8 ;
var (cmpstr1) string 8 ;
var (cmpstr2) string 8 ;

var (result) bool ;

proc .search.
  to (cmpstr) strcpy
  (cmpstr) upstr
  (result) false bl>m
  0 count b>m 
  BEGIN
    count mem+ m>a getBEMArec
    BEMArec_Text to (cmpstr1) strcpy (cmpstr1) upstr
    BEMArec_Ziffer to (cmpstr2) strcpy (cmpstr2) upstr
     (cmpstr) to (cmpstr1) .$=. IF true (result) bl>m ENDIF   
     (cmpstr) to (cmpstr2) .$=. IF true (result) bl>m ENDIF   
  (result) m>al .true=. flag> BEMArec_Wert m>a 999 .=. .>or. UNTIL
  (result) m>al .true=.
;

var str1 string 10 ;
var str2 string 10 ;

proc .datum 
  datum m>al 2 u.r '.' emit datum adr+ m>al 2 u.r '.' emit
  datum adr2+ m>a 4 u.r cr
;  

proc putpat 

 PatNr	m>a <# # # # # #> to patfile fput$ $0A0D patfile fputw
 Name			  to patfile fput$ $0A0D patfile fputw
 Vornamen		  to patfile fput$ $0A0D patfile fputw
 PK			  to patfile fput$ $0A0D patfile fputw
 Einheit		  to patfile fput$ $0A0D patfile fputw
 Dienstgrad		  to patfile fput$ $0A0D patfile fputw
 Dsteintritt		  to patfile fput$ $0A0D patfile fputw
 DZE			  to patfile fput$ $0A0D patfile fputw
 status	m>al 0 <# # # #>  to patfile fput$ $0A0D patfile fputw
 TelefonD		  to patfile fput$ $0A0D patfile fputw
 TelefonP		  to patfile fput$ $0A0D patfile fputw
 Lastrech		  to patfile fput$ $0A0D patfile fputw
;

proc getpat
 
( 1  ) patfile to buf fget$ buf .number. PatNr a>m
( 2  ) patfile to Name fget$
( 3  ) patfile to Vornamen fget$
( 4  ) patfile to PK fget$
( 5  ) patfile to Einheit fget$
( 6  ) patfile to Dienstgrad fget$
( 7  ) patfile to Dsteintritt	fget$
( 8  ) patfile to DZE	fget$
( 9  ) patfile to buf fget$ buf .number. status al>m
( 10 ) patfile to TelefonD fget$
( 11 ) patfile to TelefonP fget$
( 12 ) patfile to Lastrech fget$ 

;

var plfname string 80 ;
Var TEXTCOMM string 75 ;
var dstatok " 8765432112345678" ;
var dstatuk " 8765432112345678" ;
var plfile file ;
var maxpat word ;

proc AddLstg
  " Leistung wird erfasst!" $. cr
  datum m>ba Lstg_datum ba>m
  PatNr m>a 0 <# # # # # # #> adrpush " DATA\PAT" apop to buf concat
  " .DAT" adr>a buf to plfname concat
  plfname to plfile fassign

  plfile fopen

  plfile to buf fget$ buf .number. maxpat a>m

  1 do
     plfile to buf fget$
  loop  

  " 00.00.0000" to str1 strcpy
  Lstg_datum m>al 0 <# # # #> to str1 , 2 i/copy
  Lstg_datum adr+ m>al 0 <# # # #> to str1 d+ d+ d+ , 2 i/copy
  Lstg_datum adr2+ m>a 0 <# # # # # #> to str1 d+ d+ d+ d+ d+ d+ , 4 i/copy
  str1 to plfile fput$ 32 plfile fputb
  Lstg_Zahn m>al 0 <# # # #> to plfile fput$ 32 plfile fputb
  Lstg_Anzahl m>al 0 <# # # #> to plfile fput$ 32 plfile fputb
  Lstg_Ziffer m>a 0 <# # # # #> to plfile fput$ 32 plfile fputb
  Lstg_Faktor m>a 0 <# # # # # #> to plfile fput$ $0A0D plfile fputw
  Lstg_Ziffer m>a 
  CASE
  083 OF TEXTCOMM to plfile fput$ $0A0D plfile fputw maxpat mem+ ;;
  002 OF DSTATOK to plfile fput$ $0A0D plfile fputw 
  	 DSTATUK to plfile fput$ $0A0D plfile fputw maxpat mem+ mem+ ;;
  ELSE
  ENDCASE
  &0 plfile fseek
  maxpat m>a 1+ 0 <# # # # # #> to plfile fput$
  plfile fclose
;

proc Erfassung
  clrscr
  " Patient #" $. PatNr m>a 0 <# # # # # # #> $. cr cr  
BEGIN
  " Leistung: " $. str1 6 expect 
  (long)
  str1 .search. IF 
     " Leistung: " $. 
     BEMArec_Text $. "  ,   " $. BEMArec_Ziffer $. cr
     BEMArec_nr m>a Lstg_Ziffer a>m
     CASE
     083 of 	" TEXT: " $. 65 TextComm expect 
     		AddLstg
     		.F. ;;
     001 of     .T. ;; 	
     002 of     Lstg_Zahn 99 bl>m
     		Lstg_Anzahl 1 bl>m
     		Lstg_Faktor 23 bl>m
     		"             8765432112345678" $. cr
	        " Befund OK : " $.  DSTATOK 16 expect cr
	        " Befund UK : " $.  DSTATUK 16 expect cr
     		AddLstg
     		.F. ;;
     else
	     " Zahn    : " $. str1 2 expect cr str1 .number. flag> Lstg_Zahn al>m 
	     " Anzahl  : " $. str1 3 expect cr str1 .number. flag> Lstg_Anzahl al>m

             status m>al 5 .=. IF
               " Satz (x.x): " $. str1 4 expect str1 .number. flag> .0<>. .>and.
               IF
                 Lstg_Faktor a>m
               ELSE
                 BEMArec_GOZfaktor m>a Lstg_Faktor a>m apush 
                 " Satz x10: " $. apop u.d
               ENDIF
               cr
             ELSE
               10 Lstg_Faktor b>m
             ENDIF

	     Lstg_Anzahl m>al .0<>. flag> Lstg_Zahn m>al .0<>. .>and.
	     .>and. .>and. IF AddLstg ELSE " Cancelled" $. cr ENDIF
	     .F.
     ENDCASE
  ELSE
    " Unbekannte BEMA Ziffer!" $. cr 7 emit  .F.
  ENDIF
UNTIL

;


proc NeuPat (long)
  LfdNr mem+ m>a PatNr a>m
 BEGIN
  clrscr
  " Patient #" $. PatNr m>a 0 <# # # # # # #> $. cr cr cr
  " Name........ :" $. Name 40 expect cr
  " Vornamen.... :" $. Vornamen 40 expect cr
  " >>> Status: 0=GWDL, 1=SaZ, 2=BS, 3=W, 4=zivil/Kasse, 5=zivil/privat" $. cr
  " Status (0..5):" $. buf 1 expect cr buf .number. status al>m
  apush 4 .=. flag> apop 5 .=. .>or. IF
  " Geburtsdatum :" $. PK 14 expect cr
  " Str,Nr,....  :" $. Einheit  65 expect cr
  " PLZ/Ort....  :" $. TelefonP 40 expect cr
  " Telefon..... :" $. TelefonD 20 expect cr
  " Anrede ......:" $. dienstgrad 10 expect cr
  ELSE
  " PK.......... :" $. PK 14 expect cr
  " Dienstgrad.. :" $. dienstgrad 10 expect cr 
  " Einheit .... :" $. Einheit 30 expect cr
  " Dsteintritt. :" $. Dsteintritt 10 expect cr
  " DZE......... :" $. DZE 10 expect cr
  " TelefonD.... :" $. TelefonD 20 expect cr
  " TelefonP.... :" $. TelefonP 20 expect cr
  ENDIF
  cr cr
  " Sind diese Angaben richtig ? [J/N/ESC] " $.
  key 
  $20 or 'j' .=. IF .T. 
      ELSE $3B .=. IF LfdNr mem- m>a PatNr , 0 a>m 
      " Kein Patient ausgewhlt" to Name strcpy exit endif
  ENDIF
 UNTIL 
  patfile fopen
  PatNr m>a <# # # # # # #> to patfile fput$
  PatNr m>a 1- 1 DO
    patfile to buf fget$ ( PatNr )  
    patfile to buf fget$ ( Name )
    patfile to buf fget$ ( Vornamen )
    patfile to buf fget$ ( PK ) 
    patfile to buf fget$ ( Einheit )
    patfile to buf fget$ ( Dienstgrad )
    patfile to buf fget$ ( Diensteintritt )
    patfile to buf fget$ ( DZE )
    patfile to buf fget$ ( Status )
    patfile to buf fget$ ( TelefonD )
    patfile to buf fget$ ( TelefonP )
    patfile to buf fget$ ( LastRech )
  LOOP
  patfile to buf fget$
  PutPat
  patfile fclose
  
  
  PatNr m>a 0 <# # # # # # #> adrpush " DATA\PAT" apop to buf concat
  " .DAT" adr>a buf to plfname concat
  plfname to plfile fassign
  plfile fcreate
  " 0000" to plfile fput$ $0A0D plfile fputw
  plfile fclose
  
  (short)  
;


var patfound bool ;
var patstr string 50 ;

: .searchpat. ( searchstr in SI )
  to patstr strcpy
  patstr upstr
  patfound false bl>m  
  patfile fopen

  patfile to str1 fget$

  LfdNr m>a 1 do ipush 

    getpat 
    Name to buf strcpy buf upstr
    Name $. ':' emit PK $. '=' emit patstr $. cr
    patstr to buf  .$=. IF patfound true bl>m leave ENDIF  
    PK to buf strcpy buf upstr
    patstr to buf .$=. IF patfound true bl>m leave ENDIF

  ipop loop  

  patfile fclose
  patfound m>al .true=. IF .T. 
  			ELSE " Patient nicht gefunden!" $. key 
  			     PatNr 0 b>m
  			     " Kein Patient ausgewhlt" to Name strcpy
  			     " " to PK strcpy
  			     " " to Vornamen strcpy
  			     .F.
  			ENDIF

;  

proc AltPat
  clrscr
  " Bitte geben Sie Name oder PK des Patienten ein!" $. cr
  " --> " $. buf 40 expect
  buf .searchpat.
;


proc pospat ( Pat# in AX )
  apush 
  LfdNr m>d 1 .>?<. IF
    patfile fopen
    patfile to buf fget$
    1 apop DO
      getpat 
    LOOP
    patfile fclose
  ELSE
    7 emit
    apop 1 .<. IF 
      0
    ELSE  
      LfdNr m>b
    ENDIF   
    patnr b>m
    , 0 .=. if " Kein Patient ausgewhlt" to Name strcpy
    0 Vornamen bl>m
    endif
  ENDIF   
;

proc PatRechUPD  
   PatNr m>a apush
   patfile fopen
   1 apop apush DO 
     ipush 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to buf fget$ 
     patfile to lastrech fget$ 
     ipop
   LOOP
   
   " Ready" $. cr
   datum m>ba N2DAT to patfile fput$  
   patfile fclose
   apop PatNr a>m
;


var punktwert 	float ;
var GOZpunkt  	float ;
var Faktor    	word ;
var Summe     	float ;
var rechnung 	bool ;
var rechstart	word ;
var Summe1	float ;


proc uebersicht (long)

   Lastrech DAT2N datum m>ed d/- .0<. .not. flag>
   rechnung m>al .true=. .>and.
   IF
    cr cr cr cr cr cr cr
    7 emit "                              Keine Neuen Daten!" $. cr
    exit
   ENDIF 

   " Alexandros Zissis                            66450 Bexbach, den " $.
   datum m>ba n2dat $. cr
   "   -Zahnarzt-" $. cr
   " Saar-Pfalz-Kaserne" $. cr
   " 66450 Bexbach/Saar" $. cr
   " 06826/4469 Apparat 331" $. cr cr

   status m>al 4 .<. ( Soldat )
   IF
     Dienstgrad $. " , " $. Name $. " , " $. Vornamen $. cr
     PK $. cr
     Einheit $. cr	
     " Diensteintritt : " $. Dsteintritt $. "     " $.
     " Dienstzeitende : " $. DZE	$. cr
   ELSE  ( Zivil )
     Dienstgrad $. cr
     Name $. " , " $. Vornamen $. cr
     Einheit $. cr	
     TelefonP $. cr
   ENDIF
  
   status m>al
   case
   0  of "  Grundwehrdienstleistender" ;;
   1  of "  Soldat auf Zeit" ;;
   2  of "  Berufssoldat" ;; 
   3  of "  Wehrbender" ;;
   4  of "  Kassenpatient" ;;
   5  of "  Privatpatient" ;;
   endcase
   $. cr
   status m>al 4 .<. 
   IF
     " Telefon (dienst.): " $. TelefonD $. "      Telefon (pvt): " $.
     TelefonP $. cr cr
   ELSE 
     cr cr 
   ENDIF

  rechnung m>al .true=. 
  IF
    " DATA\RECHNUNG.CTL" to rechnfile fassign
    rechnfile fopen
    rechnfile to buf fget$ buf .number. rechLfdNr a>m 1 do
      ipush
      rechnfile to buf fget$
      ipop
    LOOP     
    $204F rechnfile fputw rechlfdNr m>a 0 <# # # # # # #> to rechnfile fput$
    $20 rechnfile fputb
    PatNr m>a 0 <# # # # # # #> to rechnfile fput$  $20 rechnfile fputb
    datum m>ba N2DAT to rechnfile fput$ $20 rechnfile fputb

    LastRech to rechnfile fput$ 

    "  R E C H N U N G   " $. rechLfdNr m>a 0 <# # # # # # #> $. 
    "  vom " $. datum m>ba n2dat $. cr
    "  ======================================" $. cr cr cr
    %0 Summe f>m  
    %0 Summe1 f>m
  ENDIF
  
  
  

  " Datum      |Zahn| Anz. Leistung" $. cr
  " -----------+----+--------------------------------------------------" $. cr
  PatNr m>a 0 <# # # # # # #> adrpush " DATA\PAT" apop to buf concat
  " .DAT" adr>a buf to plfname concat
  plfname to plfile fassign
  plfile fopen
  plfile to buf fget$ buf .number. 
  1 
  DO ipush

  rechnung m>al .true=. 
  IF
   plfile to buf fget$
   buf , 10 adrn+ 0 bl>m   
   buf dat2n bapush 
   lastrech dat2n ba>ed
   bapop d/- .0>.
  ELSE 
   plfile to buf fget$
   .T.
  ENDIF 
IF 
   
   buf , 21 adrn+ .number. Lstg_Faktor a>m buf
   buf , 17 adrn+ to str1 , 3 i/copy str1 , 3 adrn+ 0 bl>m str1 .number.
   case
   083 of	buf to str1 , 10 i/copy str1 , 11 adrn+ 0 bl>m
   		str1 $. "  |    | " $.
   		plfile to buf fget$ buf $. 
		ipop i+ ipush
 	;;

   002 of	buf to str1 , 10 i/copy str1 , 11 adrn+ 0 bl>m
		str1 $. "  | " $.
    		buf , 11 adrn+ m>bl emit  
		buf , 12 adrn+ m>bl emit
		"  | " $.
		buf , 14 adrn+ m>bl emit
		buf , 15 adrn+ m>bl emit  
		'x' emit 32 emit
		buf , 17 adrn+ to str1 , 3 i/copy str1 , 3 adrn+ 0 bl>m str1 .number.
		getBEMArec 
		BEMArec_Text $.  
		GO-Z m>f GOZPunkt f>m
		rechnung m>al .true=. IF

		  buf , 14 adrn+ m>al '0' - 10 * apush  
		  buf , 15 adrn+ m>al '0' - bpop + str1 a>m     

  	      		status m>al 5 .=. if
 	          	 , 23 Faktor a>m
	   	 	 '(' emit

		         0 , 1 <# # # # #> $.  ')' emit 32 emit

	        	 BEMArec_GOZWert w/m>F GOZPunkt m>f f*
	        	 %10 F/ str1 w/m>f f*
	        	 Summe1 m>F f+ Summe1 f>m  

	        	 BEMArec_GOZWert w/m>F GOZPunkt m>f f*
	        	 Faktor w/m>F F* %100 F/ str1 w/m>f f*
	        	 Summe m>F f+ Summe f>m  
	        	 "        DM " $.
	        	 BEMArec_GOZWert w/m>F  GOZPunkt m>f f*
	        	 Faktor w/m>F F* %100 F/ str1 w/m>f f* 
	         	 DM.  
	        	 "  Satz: " $. Faktor w/M>f %10 F/ DM.
                  	else
                  	                  	
 		  	 BEMArec_Wert w/m>F Punktwert m>F f* str1 w/m>f f*
		  	 Summe m>F f+ Summe f>m  
		  	 "        DM " $.
		  	 BEMArec_Wert w/m>F Punktwert m>F f* str1 w/m>f f* DM.

	        	 BEMArec_GOZWert w/m>F GOZPunkt m>f f*
	        	 %10 F/ str1 w/m>f f*
	        	 Summe1 m>F f+ Summe1 f>m  

 	  	  	endif
		ENDIF
   		plfile to buf fget$ 
		rechnung m>al .false=. IF
  		  cr
   		  buf to str1 , 10 i/copy str1 , 11 adrn+ 0 bl>m
   		  "            |    | " $. buf $.  cr
   		ENDIF 
   		plfile to buf fget$ 
		rechnung m>al .false=. IF   		
   		  "            |    | 8765432112345678" $. cr                   
   		  "            |    | " $. buf $. 
		ENDIF
		ipop i+ i+ ipush
   	;;
   else
    buf to str1 , 10 i/copy str1 , 11 adrn+ 0 bl>m
    str1 $. "  | " $.
    buf , 11 adrn+ m>bl emit  
    buf , 12 adrn+ m>bl emit
    "  | " $.
    buf , 14 adrn+ m>bl emit
    buf , 15 adrn+ m>bl emit  
    'x' emit 32 emit
    buf , 17 adrn+ to str1 , 3 i/copy str1 , 3 adrn+ 0 bl>m str1 .number.
    getBEMArec 
    BEMArec_Text $.  

    rechnung m>al .true=. IF
      buf , 14 adrn+ m>al '0' - 10 * apush  
      buf , 15 adrn+ m>al '0' - bpop + str1 a>m    

      status m>al 5 .=. if
        Lstg_Faktor m>a  Faktor a>m
        '(' emit
        BEMArec_GOZ m>a 1000 .<. IF
          <# # # # #> $.  ')' emit 32 emit
          GO-Z m>f GOZPunkt f>m
        ELSE
          10000 .<. .not. IF
           10000 - 
           GO- m>f GOZPunkt f>m
          ENDIF
          <# # # # # #> $.  ')' emit
        ENDIF

	BEMArec_GOZWert w/m>F GOZPunkt m>f f*
	%10 F/ str1 w/m>f f*
	Summe1 m>F f+ Summe1 f>m  


        BEMArec_GOZWert w/m>F GOZPunkt m>f f*
        Faktor w/m>F F* %100 F/ 
        str1 w/m>f f*
        Summe m>F f+ Summe f>m  
        "        DM " $.
        BEMArec_GOZWert w/m>F  GOZPunkt m>f f*
        Faktor w/m>F F* %100 F/ 
        str1 w/m>f f* DM.  
        "  Satz: " $. Faktor w/M>f %10 F/ DM.
      else  
        BEMArec_Wert w/m>F Punktwert m>F f* str1 w/m>f f*
        Summe m>F f+ Summe f>m  
        "        DM " $.
        BEMArec_Wert w/m>F Punktwert m>F f* str1 w/m>f f* DM.

      	 BEMArec_GOZWert w/m>F GOZPunkt m>f f*
      	 %10 F/ str1 w/m>f f*
      	 Summe1 m>F f+ Summe1 f>m  
      	 
      endif  
    ENDIF
   endcase  
   cr 

ENDIF   

   ipop
  LOOP
  plfile fclose
  rechnung m>al .true=. IF
    " -----------+----+--------------------------------------------------" $. cr
    "                   Gesamtsumme : DM " $.
    summe m>f DM. cr 
      
  $20 rechnfile fputb
  summe m>f %100 f* buf d/f>m
  buf m>ba <# # # '.' hold # # # # # #>  to rechnfile fput$
  $20 rechnfile fputb

  summe1 m>f %100 f* buf d/f>m
  buf m>ba <# # # '.' hold # # # # # #>  to rechnfile fput$
  
  $0A0D rechnfile fputw 

  rechnfile &0 fseek
  rechLfdNr mem+ m>a 0 <# # # # # # #> to rechnfile fput$
  rechnfile fclose 
  patrechupd 
  ELSE
    " -----------+----+--------------------------------------------------" $. cr
  ENDIF
;

var TagDatum " 01.01.1900" ;
var TagDatum2 " 01.01.1900" ;

proc TagMeld
  clrscr
  datum m>ba N2DAT to TagDatum2 strcpy
  " Tagesmeldung vom :" $. TagDatum2 $. 13 emit
  " Tagesmeldung vom :" $. 10 TagDatum expect  13 emit
  TagDatum strlen TagDatum to Tagdatum2 i/copy
  " Tagesmeldung vom :" $. TagDatum2 $. cr cr  
  "  PRN" adr>a TagDatum2 to buf concat
  BUF adr>a
  " TAGMELD.COM" EXEC
  " Tagesmeldung erstellt !" $. key
;

var (XRECHX) double ;
proc Xrech
  clrscr
  datum m>ba N2DAT to TagDatum2 strcpy
  " Rechnung vom :" $. TagDatum2 $. 13 emit
  " Rechnung vom :" $. 10 TagDatum expect  13 emit
  TagDatum strlen TagDatum to Tagdatum2 i/copy
  " Rechnung vom :" $. TagDatum2 $. cr cr  
  TagDatum2 DAT2N datum ba>m
;

var Memo1 string 80 ;
var SFN " DDMMYYYY.SKA" ;
var VFN " DDMMYYYY.VTA" ;

proc bezahlt
  clrscr cr cr cr cr
  PatNr m>a 0 <# # # # # # $20 hold #> adr>a LastRech to memo1 concat
  " BEZAHLT.COM" , Memo1 EXEC 
  cr cr cr cr cr " -beliebige Taste drcken- " $.
  key
;


proc Sachkosten
  datum m>a ah0 0 <# # # #> m>a SFN A>M
  datum m>a u/16 u/16 0 <# # # #> m>a SFN adr2+ A>M
  datum adr2+ m>a 0 <# # # # # #> m>ba SFN adr2+ adr2+ BA>M

  "  /C SACHKO >DATA\" , SFN to Memo1 concat
  " \COMMAND.COM" , Memo1 EXEC 

  "  /C COPY DATA\" , SFN to buf concat
  "  PRN" adr>a buf to Memo1 concat 	
  " \COMMAND.COM" , Memo1 EXEC 
;

proc Vorteil
  datum m>a ah0 0 <# # # #> m>a VFN  A>M
  datum m>a u/16 u/16 0 <# # # #> m>a VFN adr2+ A>M
  datum adr2+ m>a 0 <# # # # # #> m>ba VFN adr2+ adr2+ BA>M

  "  /C VORTEIL >DATA\" , VFN to Memo1 concat
  " \COMMAND.COM" , Memo1 EXEC 

  "  /C COPY DATA\" , VFN to buf concat
  "  PRN" adr>a buf to Memo1 concat 	
  " \COMMAND.COM" , Memo1 EXEC 
;

proc Total
  " " adr>a " VORTEIL.COM"  EXEC  
  " /C COPY DATA\RECHNUNG.SKV DATA\RECHNUNG.CTL >NUL" adr>a " \COMMAND.COM" EXEC
  wait
;


proc mydoserr
  " Stammdaten Datei wird neu erstellt!" $. cr key
  " DATA\RECHNUNG.CTL" to rechnfile fassign
  rechnfile fcreate
  " 00001" to rechnfile fput$ $0A0D rechnfile fputw
  " x LfdNr PatNr Rech.vom   seit       Summe    GOZx1  " 
  to rechnfile fput$ $0A0D rechnfile fputw
  rechnfile fclose
  patfile fcreate
  " 00000" to patfile fput$
  $0A0D patfile fputw
  patfile fclose
  make doserr (doserrex)
  patfile fopen
;

: main init
  memsizes( $100 0 )
( ******************************************************* )

  %1.60 Punktwert F>m	( 1 BEMA Punkt = DM 1,60 )
  %0.11 GO-Z F>m	( 1 GOZ  Punkt = DM 0,11 )
  %0.10 GO- F>m	( 1 GO- Punkt = DM 0,10 )

( ******************************************************* ) 

  '0' LEADING bl>m
  2 setdecimals
  sysdate datum xab ba>m 
  PatNr 0 b>m
  " Kein Patient ausgewhlt" to Name strcpy
  " " to PK strcpy
  " " to Vornamen strcpy
  getBEMA
  make doserr mydoserr
  " DATA\STAMM.DAT" to patfile fassign
  patfile fopen
  patfile to buf fget$
  patfile fclose
  buf .number. LfdNr a>m  
  (long)
  BEGIN
    clrscr
    " Zahnarzt V0.99                                                     " $. .datum 
    " Copyright (C) 1994 by A.Zissis" $. cr 
    " ===============================================================================" $. cr cr
    " <F1>......... Neuer Patient            <F8> .......... Tagesmeldung erstellen" $. cr cr
    " <F2>......... Patient auswhlen        <F9> ................ Rechnung bezahlt" $. cr cr
    " <F3>......... Leistung eingeben        <F10> .......Sachkostenausgleich (TrV)" $. cr cr
    " <F4>......... Rechnung drucken         <F11> .........Vorteilsausgleich (TrV)" $. cr cr
    " <F5>......... Rechnung anzeigen        <F12> .....Vorteilsausgleich bersicht" $. cr cr 
    " <F6>......... Karte drucken            " $. cr cr 
    " <F7>......... Karte anzeigen           " $. cr cr cr cr
    " <ALT-X>...... ENDE" $. cr cr
    " ===============================================================================" $. cr
        " Patient: " $. PatNr m>a 0 <# # # # # #> $. "  /" $.
    LfdNr m>a 0 <# # # # # #> $.    
    "  : " $. Name $. " , " $. Vornamen $. "   : " $. PK $.
    cr
    xkey apush 
      patnr m>a .0=. IF
        apop
        case 
        $12D of ;;
        $13b of ;;
        $13c of ;;
        $142 of ;;
        $143 of ;;
        $144 of ;;
        $185 of ;;
        $186 of ;;
        '+'  of ;;
        '-'  of ;;
        else , $200
        endcase
       ELSE 
        apop 
      ENDIF
    CASE
    $12D OF .T. ;;
    $13B OF NeuPat .F. ;;
    $13C OF AltPat .F. ;;
    $13D OF PatNr .0<>. if Erfassung else 7 emit endif .F. ;;
    $13E OF rechnung true bl>m 
     	    datum m>ba (XRECHX) ba>m xrech
            make emit (pemit) uebersicht 12 emit make emit (emit) 
            (XRECHX) m>ba datum ba>m
            .F. 
            ;;
    $13F OF rechnung true bl>m clrscr 
            datum m>ba (XRECHX) ba>m xrech 
            uebersicht key 
            (XRECHX) m>ba datum ba>m
            .F. 
            ;;
    $140 OF rechnung false bl>m 
           make emit (pemit) uebersicht 12 emit make emit (emit) .F. ;;
    $141 OF rechnung false bl>m clrscr uebersicht key .F. ;;
    $142 OF TagMeld .F. ;;
    $143 OF Bezahlt .F. ;;
    $144 OF Sachkosten .F. ;;
    $185 OF Vorteil .F. ;; 
    $186 OF Total .F. ;;
    '+' OF PatNr mem+ m>a pospat .F. ;;
    '-' OF PatNr mem- m>a pospat .F. ;;
    else 7 emit .F.
    ENDCASE    
  UNTIL
;
