(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
	*                   MOUSE-Support (MSDOS)  V1.00	   *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 13B 25.08.93                   *
        *                                                          *
        ************************************************************
)


: .m-reset. ( Resets Mouse and returns CF=1 if Mouse installed )
  $33 , $0 intr
  d.AX m>a
  [ $D1 $D0 ]  ( RCL AX,1 )
;

: m-cursor
  $33 , $1 intr
;

: -m-cursor
  $33 , $2 intr
;

: m-pos ( returns mouse-position as BX=X-pos AX=Y-pos / Buttons in DI )
  $33 , $3 intr
  d.bx m>a $0007 and a>d 
  d.cx m>b
  d.dx m>a
;  

: m-tpos ( returns mouse-position as BX=X-pos AX=Y-pos / Buttons in DI )
  $33 , $3 intr
  d.bx m>a $0007 and a>d 
  d.cx m>b
  d.dx m>a
  u/2 u/2 u/2 xab u/2 u/2 u/2 xab
;  
  
: m-xrange ( left x-marg in bx , right x-marg in ax )
  d.cx b>m
  d.dx a>m
  $33 , $7 intr
;

: m-yrange ( upper y-marg in bx , lower y-marg in ax )
  d.cx b>m
  d.dx a>m
  $33 , $8 intr
;

: m-txrange ( left x-marg in bl , right x-marg in al )
  d.dx 2* 2* 2* a>m
  d.cx b>a 2* 2* 2* a>m
  $33 , $7 intr
;

: m-tyrange ( upper y-marg in bl , lower y-marg in al )
  d.dx 2* 2* 2* a>m
  d.cx b>a 2* 2* 2* a>m
  $33 , $8 intr
;


: m-xy ( x-pos in bx , y-pos in ax )
  d.cx b>m
  d.dx a>m
  $33 , $4 intr
;

: m-txy ( x-pos in bx , y-pos in ax )
  2* 2* 2* xab 2* 2* 2* xab
  d.cx b>m
  d.dx a>m
  $33 , $4 intr
;

: m-mikpix ( mickey/pixel ration mik/pix x in bx ,mik/pix y in ax )
	   ( default is 8 , 16 )
  d.cx b>m
  d.dx a>m
  $33 , $F intr
;

const stdcrsr1 &$F0000f04 ;
const stdcrsr2 &$FFFF7F00 ;


: m-defcursor ( smask in AX cmask in BX )
  d.cx b>m
  d.dx a>m
  0 d.bx b>m
  $33 , $A intr
;

: m-defgcursor 
 ( bx: li rand )
 ( ax: oberer rand )
 ( di: ofs der Bitmask )
  d.Bx b>m
  d.cx a>m
  d.dx d>m
  ds>a d.es a>m
  $33 , $9 intr
;


: m-hwcursor ( 1. line in bx, last line in AX )
  d.cx b>m
  d.dx a>m
  1 d.bx b>m
  $33 , $A intr
;

const mb-left  $1 ;
const mb-right $2 ;
const mb-mid   $4 ;

: mb-pressed ( button in BX result in AX )
  xab 1- xab d.bx b>m
  $33 , $5 intr
  d.bx m>a
;

: mb-released ( button in BX result in AX )
  xab 1- xab d.bx b>m
  $33 , $6 intr
  d.bx m>a
;

: mb-pospress ( button in BX result: x in BX / y in AX )
  xab 1- xab d.bx b>m
  $33 , $5 intr
  d.dx m>a
  d.cx m>b
;

: mb-posrel ( button in BX result: x in BX / y in AX )
  xab 1- xab d.bx b>m
  $33 , $6 intr
  d.dx m>a
  d.cx m>b
;

var (m-xold) byte ;
var (m-yold) byte ;
var (m-x) byte ;
var (m-y) byte ;


: .m-moved.
  m-tpos (m-x) bl>m (m-y) al>m
  (m-xold) m>al (m-x) m>bl .<>. flag>
  (m-yold) m>al (m-y) m>bl .<>. .>or.
;
