(
        ************************************************************
        *         NAXOS Version 2.13  16-Bit Runtime library       *
        *                                                          *
        *                   MSDOS-XMS Support V1.02                *
        *                                                          *
        * (C) 1989,90,91,92,93 by K.Peper, A.Zissis, I.Tossounidis *
        *                                                          *
        *                      Rev. 14  26.01.94                   *
        *                                                          *
        ************************************************************
)

: XMS-INIT overload
  386 xms-id b>m ( 386 mode )
  XMEM386
  , 0 
  [ $8E $E0 ( mov fs,ax )
  ds>a
  $8E $E8 ] ( mov gs,ax )
  ~xms-init 
;

: XMS-MOVEB
  ( ************************************************ )
  ( ** in: 	bx:ax = linear source address     ** )
  ( **		es:di = linear destination adress ** )
  ( **		ecx = byte count		  ** )
  ( ** out:	---				  ** )
  ( ************************************************ )

    ba>xb
    ed>xa
  [ 
    $66 $8B $D0			( mov edx,eax )
    $64 $67 $8A $03		( mov al,fs:[ebx] )
    $64 $67 $88 $02		( mov fs:[edx],al )
    $66 $43			( inc ebx )
    $66 $42			( inc edx )
    $E2 -14			( LOOP -14 )
  ]  
;
  
: XMS-MOVEW
  ( ************************************************ )
  ( ** in: 	bx:ax = linear source address     ** )
  ( **		es:di = linear destination adress ** )
  ( **		ecx = word count		  ** )
  ( ** out:	---				  ** )
  ( ************************************************ )

    ba>xb
    ed>xa
[
    $66 $8B $D0			( mov edx,eax )
    $64 $67 $8B $03		( mov ax,fs:[ebx] )
    $64 $67 $89 $02		( mov fs:[edx],ax )
    $66 $43			( inc ebx )
    $66 $43			( inc ebx )
    $66 $42			( inc edx )
    $66 $42			( inc edx )
    $E2 -18			( LOOP -18 )
  ]  
;


: XMS-MOVED
  ( ************************************************ )
  ( ** in: 	bx:ax = linear source address     ** )
  ( **		es:di = linear destination adress ** )
  ( **		ecx = dword count		  ** )
  ( ** out:	---				  ** )

  ( ************************************************ )
    ba>xb
    ed>xa
  [
    $66 $8B $D0			( mov edx,eax )
    $64 $67 $66 $8B $03		( mov eax,fs:[ebx] )
    $64 $67 $66 $89 $02		( mov fs:[edx],eax )
    $66 $43			( inc ebx )
    $66 $43			( inc ebx )
    $66 $43			( inc ebx )
    $66 $43			( inc ebx )
    $66 $42			( inc edx )
    $66 $42			( inc edx )
    $66 $42			( inc edx )
    $66 $42			( inc edx )
    $E2 -28			( LOOP -28 )
  ]  
;
